<%@page errorPage="exceptionHandler.jsp"
        import="dermi.*, dermi.registry.*, dermi.samples.simple.*, org.planet.snap.*,
                java.util.*, java.io.*, java.util.logging.*, java.net.*, javax.naming.*"
%>

<%
  response.setHeader("Cache-Control","no-cache"); //HTTP 1.1
  response.setHeader("Pragma","no-cache"); //HTTP 1.0
  response.setDateHeader ("Expires", 0); //prevents caching at the proxy server

  Logger logger = Logger.getLogger (this.getClass().getName());
  String connectP2PUrl = request.getParameter ("p2purl");
  String serverName = (String) application.getAttribute ("serverName");
  IApplication snapSkel = (IApplication) application.getAttribute ("SNAPSkel");

  if (connectP2PUrl != null && serverName != null && snapSkel != null) {
    
    connectP2PUrl = connectP2PUrl.substring(6, connectP2PUrl.length());
	int end_domain = connectP2PUrl.indexOf("/");

		
    logger.info ("Connecting to " + connectP2PUrl + "...");

	String document = "";
    if (end_domain>0) {
      document = connectP2PUrl.substring(end_domain,connectP2PUrl.length());
      connectP2PUrl  = "p2p://snap.deim.urv.net/" + connectP2PUrl.substring(0, end_domain);
    }
    else connectP2PUrl  = "p2p://snap.deim.urv.net/" + connectP2PUrl;

    IApplication toLoadSnapAppStub = Application.loadMainSNAPApp (application.getRealPath (File.separator), connectP2PUrl);

    // Gotta lookup the specified p2purl searching for a decentralized web application
    Properties snapAppProps = snapSkel.redirectToSnapApp (connectP2PUrl, "." + File.separator + "webapps", toLoadSnapAppStub);

    if (snapAppProps.getProperty ("LOCAL").equalsIgnoreCase ("true")) {
      // Check whether to wait for local deployment to be complete
      if (snapAppProps.getProperty ("TIMEOUT").equalsIgnoreCase ("true")) {
        Thread.currentThread().sleep (5000);
      }
      response.sendRedirect ("http://" + serverName + ":" + request.getServerPort() + "/" + snapAppProps.getProperty ("URL") + document);
    }
    else {
      response.sendRedirect (response.encodeRedirectURL (snapAppProps.getProperty ("URL")) + document);
    }

  }
  else {
    throw new NullPointerException ("Invalid parameter received in connect.jsp!");
  }

%>
